Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 1089)
+++ inc/admin/lib.dc.page.php	(revision 1049)
@@ -49,39 +49,215 @@
 	
 	# Top of admin page
-	public static function open($title='',$head='',$popup=false)
-	{
-		global $core, $_ctx;
-		
-		$_ctx->popup = (boolean) $popup;
-		$_ctx->page_header = $head;
-		$_ctx->fillPageTitle($title);
-		
-		ob_start();
+	public static function open($title='', $head='')
+	{
+		global $core;
+		
+		# List of user's blogs
+		if ($core->auth->blog_count == 1 || $core->auth->blog_count > 20)
+		{
+			$blog_box =
+			'<p>'.__('Blog:').' <strong title="'.html::escapeHTML($core->blog->url).'">'.
+			html::escapeHTML($core->blog->name).'</strong>';
+			
+			if ($core->auth->blog_count > 20) {
+				$blog_box .= ' - <a href="blogs.php">'.__('Change blog').'</a>';
+			}
+			$blog_box .= '</p>';
+		}
+		else
+		{
+			$rs_blogs = $core->getBlogs(array('order'=>'LOWER(blog_name)','limit'=>20));
+			$blogs = array();
+			while ($rs_blogs->fetch()) {
+				$blogs[html::escapeHTML($rs_blogs->blog_name.' - '.$rs_blogs->blog_url)] = $rs_blogs->blog_id;
+			}
+			$blog_box =
+			'<p><label for="switchblog" class="classic">'.
+			__('Blogs:').' '.
+			$core->formNonce().
+			form::combo('switchblog',$blogs,$core->blog->id).
+			'</label></p>'.
+			'<noscript><p><input type="submit" value="'.__('ok').'" /></p></noscript>';
+		}
+		
+		$safe_mode = isset($_SESSION['sess_safe_mode']) && $_SESSION['sess_safe_mode'];
+		
+		# Display
+		header('Content-Type: text/html; charset=UTF-8');
+		echo
+		'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" '.
+		' "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n".
+		'<html xmlns="http://www.w3.org/1999/xhtml" '.
+		'xml:lang="'.$core->auth->getInfo('user_lang').'" '.
+		'lang="'.$core->auth->getInfo('user_lang').'">'."\n".
+		"<head>\n".
+		'  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />'."\n".
+		'  <title>'.$title.' - '.html::escapeHTML($core->blog->name).' - '.html::escapeHTML(DC_VENDOR_NAME).' - '.DC_VERSION.'</title>'."\n".
+		
+		'  <meta name="ROBOTS" content="NOARCHIVE,NOINDEX,NOFOLLOW" />'."\n".
+		'  <meta name="GOOGLEBOT" content="NOSNIPPET" />'."\n".
+		
+		self::jsLoadIE7().
+		'  	<link rel="stylesheet" href="style/default.css" type="text/css" media="screen" />'."\n"; 
+		if (l10n::getTextDirection($GLOBALS['_lang']) == 'rtl') {
+			echo
+		'  	<link rel="stylesheet" href="style/default-rtl.css" type="text/css" media="screen" />'."\n"; 
+		}
+
+		$core->auth->user_prefs->addWorkspace('interface');
+		$user_ui_hide_std_favicon = $core->auth->user_prefs->interface->hide_std_favicon;
+		if (!$user_ui_hide_std_favicon) {
+			echo '<link rel="icon" type="image/png" href="images/favicon.png" />';
+		}
+		
+		echo
+		self::jsCommon().
+		$head;
+		
+		# --BEHAVIOR-- adminPageHTMLHead
+		$core->callBehavior('adminPageHTMLHead');
+		
+		echo
+		"</head>\n".
+		'<body id="dotclear-admin'.
+		($safe_mode ? ' safe-mode' : '').
+		'">'."\n".
+		
+		'<div id="header">'.
+		'<ul id="prelude"><li><a href="#content">'.__('Go to the content').'</a></li><li><a href="#main-menu">'.__('Go to the menu').'</a></li></ul>'."\n".
+		'<div id="top"><h1><a href="index.php">'.DC_VENDOR_NAME.'</a></h1></div>'."\n";	
+		
+		echo
+		'<div id="info-boxes">'.
+		'<div id="info-box1">'.
+		'<form action="index.php" method="post">'.
+		$blog_box.
+		'<p><a href="'.$core->blog->url.'" onclick="window.open(this.href);return false;" title="'.__('Go to site').' ('.__('new window').')'.'">'.__('Go to site').' <img src="images/outgoing.png" alt="" /></a>'.
+		'</p></form>'.
+		'</div>'.
+		'<div id="info-box2">'.
+		'<a'.(preg_match('/index.php$/',$_SERVER['REQUEST_URI']) ? ' class="active"' : '').' href="index.php">'.__('My dashboard').'</a>'.
+		'<span> | </span><a'.(preg_match('/preferences.php(\?.*)?$/',$_SERVER['REQUEST_URI']) ? ' class="active"' : '').' href="preferences.php">'.__('My preferences').'</a>'.
+		'<span> | </span><a href="index.php?logout=1" class="logout">'.sprintf(__('Logout %s'),$core->auth->userID()).' <img src="images/logout.png" alt="" /></a>'.
+		'</div>'.
+		'</div>'.
+		'</div>';
+		
+		echo
+		'<div id="wrapper">'."\n".
+		'<div id="main">'."\n".
+		'<div id="content">'."\n";
+		
+		# Safe mode
+		if ($safe_mode)
+		{
+			echo
+			'<div class="error"><h3>'.__('Safe mode').'</h3>'.
+			'<p>'.__('You are in safe mode. All plugins have been temporarily disabled. Remind to log out then log in again normally to get back all functionalities').'</p>'.
+			'</div>';
+		}
+		
+		if ($core->error->flag()) {
+			echo
+			'<div class="error"><p><strong>'.(count($core->error->getErrors()) > 1 ? __('Errors:') : __('Error:')).'</p></strong>'.
+			$core->error->toHTML().
+			'</div>';
+		}
 	}
 	
 	public static function close()
 	{
-		$res = ob_get_contents();
-		ob_end_clean();
-		
-		global $core, $_ctx;
+		global $core;
+
+		$menu =& $GLOBALS['_menu'];
+		
+		echo
+		"</div>\n".		// End of #content
+		"</div>\n".		// End of #main
+		
+		'<div id="main-menu">'."\n";
+		
+		foreach ($menu as $k => $v) {
+			echo $menu[$k]->draw();
+		}
+		
+		$text = sprintf(__('Thank you for using %s.'),'<a href="http://dotclear.org/">Dotclear '.DC_VERSION.'</a>');
+
+		# --BEHAVIOR-- adminPageFooter
+		$textAlt = $core->callBehavior('adminPageFooter',$core,$text);
+
+		echo
+		'</div>'."\n".		// End of #main-menu
+		'<div id="footer"><p>'.($textAlt != '' ? $textAlt : $text).'</p></div>'."\n".
+		"</div>\n";		// End of #wrapper
+		
+		if (defined('DC_DEV') && DC_DEV === true) {
+			echo self::debugInfo();
+		}
+		
+		echo
+		'</body></html>';
+	}
+	
+	public static function openPopup($title='', $head='')
+	{
+		global $core;
+		
+		# Display
+		header('Content-Type: text/html; charset=UTF-8');
+		echo
+		'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" '.
+		' "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n".
+		'<html xmlns="http://www.w3.org/1999/xhtml" '.
+		'xml:lang="'.$core->auth->getInfo('user_lang').'" '.
+		'lang="'.$core->auth->getInfo('user_lang').'">'."\n".
+		"<head>\n".
+		'  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />'."\n".
+		'  <title>'.$title.' - '.html::escapeHTML($core->blog->name).' - '.html::escapeHTML(DC_VENDOR_NAME).' - '.DC_VERSION.'</title>'."\n".
+		
+		'  <meta name="ROBOTS" content="NOARCHIVE,NOINDEX,NOFOLLOW" />'."\n".
+		'  <meta name="GOOGLEBOT" content="NOSNIPPET" />'."\n".
+		
+		self::jsLoadIE7().
+		'  	<link rel="stylesheet" href="style/default.css" type="text/css" media="screen" />'."\n"; 
+		if (l10n::getTextDirection($GLOBALS['_lang']) == 'rtl') {
+			echo
+			'  	<link rel="stylesheet" href="style/default-rtl.css" type="text/css" media="screen" />'."\n"; 
+		}
+		
+		echo
+		self::jsCommon().
+		$head;
+		
+		# --BEHAVIOR-- adminPageHTMLHead
+		$core->callBehavior('adminPageHTMLHead');
+		
+		echo
+		"</head>\n".
+		'<body id="dotclear-admin" class="popup">'."\n".
+		
+		'<div id="top"><h1>'.DC_VENDOR_NAME.'</h1></div>'."\n";
+		
+		echo
+		'<div id="wrapper">'."\n".
+		'<div id="main">'."\n".
+		'<div id="content">'."\n";
 		
 		if ($core->error->flag()) {
-			foreach($core->error->getErrors() as $e) {
-				$_ctx->addError($e);
-			}
-		}
-		$_ctx->page_content = $res;
-		$core->tpl->display('page_layout.html.twig');
-	}
-	
-	public static function openPopup($title='',$head='')
-	{
-		self::open($title,$head,true);
+			echo
+			'<div class="error"><strong>'.__('Errors:').'</strong>'.
+			$core->error->toHTML().
+			'</div>';
+		}
 	}
 	
 	public static function closePopup()
 	{
-		self::close();
+		echo
+		"</div>\n".		// End of #content
+		"</div>\n".		// End of #main
+		'<div id="footer"><p>&nbsp;</p></div>'."\n".
+		"</div>\n".		// End of #wrapper
+		'</body></html>';
 	}
 
@@ -99,4 +275,47 @@
 			}
 		}
+		return $res;
+	}
+	
+	private static function debugInfo()
+	{
+		$global_vars = implode(', ',array_keys($GLOBALS));
+		
+		$res =
+		'<div id="debug"><div>'.
+		'<p>memory usage: '.memory_get_usage().' ('.files::size(memory_get_usage()).')</p>';
+		
+		if (function_exists('xdebug_get_profiler_filename'))
+		{
+			$res .= '<p>Elapsed time: '.xdebug_time_index().' seconds</p>';
+			
+			$prof_file = xdebug_get_profiler_filename();
+			if ($prof_file) {
+				$res .= '<p>Profiler file : '.xdebug_get_profiler_filename().'</p>';
+			} else {
+				$prof_url = http::getSelfURI();
+				$prof_url .= (strpos($prof_url,'?') === false) ? '?' : '&';
+				$prof_url .= 'XDEBUG_PROFILE';
+				$res .= '<p><a href="'.html::escapeURL($prof_url).'">Trigger profiler</a></p>';
+			}
+			
+			/* xdebug configuration:
+			zend_extension = /.../xdebug.so
+			xdebug.auto_trace = On
+			xdebug.trace_format = 0
+			xdebug.trace_options = 1
+			xdebug.show_mem_delta = On
+			xdebug.profiler_enable = 0
+			xdebug.profiler_enable_trigger = 1
+			xdebug.profiler_output_dir = /tmp
+			xdebug.profiler_append = 0
+			xdebug.profiler_output_name = timestamp
+			*/
+		}
+		
+		$res .=
+		'<p>Global vars: '.$global_vars.'</p>'.
+		'</div></div>';
+		
 		return $res;
 	}
Index: inc/admin/prepend.php
===================================================================
--- inc/admin/prepend.php	(revision 1080)
+++ inc/admin/prepend.php	(revision 1069)
@@ -375,12 +375,3 @@
 	}
 }
-
-# Add admin default templates path
-$core->tpl->getLoader()->addPath(dirname(__FILE__).'/default-templates');
-# Set admin context
-$_ctx = new dcAdminContext($core);
-$core->tpl->addExtension($_ctx);
-
-# --BEHAVIOR-- adminPrepend
-$core->callBehavior('adminPrepend',$core,$_ctx);
 ?>
Index: inc/core/class.dc.core.php
===================================================================
--- inc/core/class.dc.core.php	(revision 1092)
+++ inc/core/class.dc.core.php	(revision 706)
@@ -39,5 +39,4 @@
 	public $rest;		///< <b>dcRestServer</b>	dcRestServer object
 	public $log;		///< <b>dcLog</b>			dcLog object
-	public $tpl;		///< <b>Twig_Environment</b>	Twig_Environment object
 	
 	private $versions = null;
@@ -96,6 +95,4 @@
 		$this->addFormater('xhtml', create_function('$s','return $s;'));
 		$this->addFormater('wiki', array($this,'wikiTransform'));
-		
-		$this->loadTemplateEnvironment();
 	}
 	
@@ -121,40 +118,4 @@
 	}
 	
-	/**
-	Create template environment (Twig_Environment instance)
-	
-	default-templates path must be added from admin|public/prepend.php with:
-	$core->tpl->getLoader()->addPath('PATH_TO/default-templates');
-	Selected theme path must be added with:
-	$core->tpl->getLoader()->prependPath('PATH_TO/MY_THEME');
-	*/
-	protected function loadTemplateEnvironment()
-	{
-		# If cache dir is writable, use it.
-		$cache_dir = path::real(DC_TPL_CACHE.'/twtpl',false);
-		if (!is_dir($cache_dir)) {
-			try {
-				files::makeDir($cache_dir);
-			} catch (Exception $e) {
-				$cache_dir = false;
-			}
-		}
-		
-		$this->tpl = new Twig_Environment(
-			new Twig_Loader_Filesystem(dirname(__FILE__).'/../swf'),
-			array(
-				'auto_reload' => true,
-				'autoescape' => 'html',
-				'base_template_class' => 'Twig_Template',
-				'cache' => $cache_dir, 
-				'charset' => 'UTF-8',
-				'debug' => DC_DEBUG,
-				'optimizations' => -1,
-				'strict_variables' => 0 //DC_DEBUG // Please fix undefined variables!
-			)
-		);
-		$this->tpl->addExtension(new dcFormExtension($this));
-		$this->tpl->addExtension(new dcTabExtension($this));
-	}
 	
 	/// @name Blog init methods
Index: inc/dbschema/upgrade.php
===================================================================
--- inc/dbschema/upgrade.php	(revision 706)
+++ inc/dbschema/upgrade.php	(revision 1083)
@@ -305,4 +305,34 @@
 				$core->con->execute($strReq);
 			}
+
+			if (version_compare($version,'2.5','<='))
+			{
+				# Try to disable daInstaller plugin if it has been installed outside the default plugins directory
+				$path = explode(PATH_SEPARATOR,DC_PLUGINS_ROOT);
+				$default = path::real(dirname(__FILE__).'/../../plugins/');
+				foreach ($path as $root)
+				{
+					if (!is_dir($root) || !is_readable($root)) {
+						continue;
+					}
+					if (substr($root,-1) != '/') {
+						$root .= '/';
+					}
+					if (($p = @dir($root)) === false) {
+						continue;
+					}
+					if(path::real($root) == $default) {
+						continue;
+					}
+					if (($d = @dir($root.'daInstaller')) === false) {
+						continue;
+					}
+					$f = $root.'/daInstaller/_disabled';
+					if (!file_exists($f))
+					{
+						@file_put_contents($f,'');
+					}
+				}
+			}
 			
 			$core->setVersion('core',DC_VERSION);
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 1092)
+++ inc/prepend.php	(revision 1069)
@@ -12,5 +12,5 @@
 
 /* ------------------------------------------------------------------------------------------- */
-#  ClearBricks, Twig, DotClear classes auto-loader
+#  ClearBricks, DotClear classes auto-loader
 if (@is_dir('/usr/lib/clearbricks')) {
 	define('CLEARBRICKS_PATH','/usr/lib/clearbricks');
@@ -46,5 +46,4 @@
 $__autoload['dcWorkspace']			= dirname(__FILE__).'/core/class.dc.workspace.php';
 $__autoload['dcPrefs']				= dirname(__FILE__).'/core/class.dc.prefs.php';
-$__autoload['dcTwigPage']			= dirname(__FILE__).'/core/class.dc.twig.page.php';
 
 $__autoload['rsExtPost']				= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
@@ -53,5 +52,4 @@
 $__autoload['rsExtUser']				= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
 
-$__autoload['dcAdminContext']				= dirname(__FILE__).'/admin/class.dc.admincontext.php';
 $__autoload['dcMenu']				= dirname(__FILE__).'/admin/class.dc.menu.php';
 $__autoload['dcPage']				= dirname(__FILE__).'/admin/lib.dc.page.php';
@@ -65,26 +63,8 @@
 $__autoload['context']				= dirname(__FILE__).'/public/lib.tpl.context.php';
 $__autoload['dcUrlHandlers']			= dirname(__FILE__).'/public/lib.urlhandlers.php';
-$__autoload['dcForm']			= dirname(__FILE__).'/admin/class.dc.form.php';
-$__autoload['dcFormExtension']			= dirname(__FILE__).'/admin/class.dc.form.php';
-$__autoload['dcTabExtension']			= dirname(__FILE__).'/admin/class.dc.tab.php';
 
 # Clearbricks extensions
 html::$absolute_regs[] = '/(<param\s+name="movie"\s+value=")(.*?)(")/msu';
 html::$absolute_regs[] = '/(<param\s+name="FlashVars"\s+value=".*?(?:mp3|flv)=)(.*?)(&|")/msu';
-
-if (@is_dir('/usr/lib/twig')) {
-	define('TWIG_PATH','/usr/lib/twig');
-} elseif (is_dir(dirname(__FILE__).'/libs/twig')) {
-	define('TWIG_PATH',dirname(__FILE__).'/libs/twig');
-} elseif (isset($_SERVER['TWIG_PATH']) && is_dir($_SERVER['TWIG_PATH'])) {
-	define('TWIG_PATH',$_SERVER['TWIG_PATH']);
-}
-
-if (!defined('TWIG_PATH') || !is_dir(TWIG_PATH)) {
-	exit('No Twig path defined');
-}
-require TWIG_PATH.'/Autoloader.php';
-Twig_Autoloader::register();
-
 /* ------------------------------------------------------------------------------------------- */
 
Index: plugins/aboutConfig/_admin.php
===================================================================
--- plugins/aboutConfig/_admin.php	(revision 1070)
+++ plugins/aboutConfig/_admin.php	(revision 270)
@@ -15,5 +15,3 @@
 		preg_match('/plugin.php\?p=aboutConfig(&.*)?$/',$_SERVER['REQUEST_URI']),
 		$core->auth->isSuperAdmin());
-
-$core->tpl->getLoader()->addPath(dirname(__FILE__).'/admtpl/','aboutConfig');
 ?>
Index: plugins/aboutConfig/index.php
===================================================================
--- plugins/aboutConfig/index.php	(revision 1089)
+++ plugins/aboutConfig/index.php	(revision 907)
@@ -12,136 +12,229 @@
 if (!defined('DC_CONTEXT_ADMIN')) { return; }
 
-class adminPageAboutConfig
-{
-	public static $p_url = 'plugin.php?p=aboutConfig';
-	
-	# Update local settings
-	public static function updLocal($form)
-	{
-		self::updSettings($form);
-	}
-	
-	# Update global settings
-	public static function updGlobal($form)
-	{
-		self::updSettings($form,true);
-	}
-	
-	# Update settings
-	protected static function updSettings($form,$global=false)
-	{
-		global $core,$_ctx;
-		
-		$part = $global ? 'global' : 'local';
-		$prefix = $part.'_';
-		
-		try {
-			foreach ($core->blog->settings->dumpNamespaces() as $ns => $namespace) {
-				$core->blog->settings->addNamespace($ns);
-				$ns_settings = $global ? 
-					$namespace->dumpGlobalSettings() : $namespace->dumpSettings();
-				
-				foreach ($ns_settings as $k => $v) {
-					// need to cast type
-					$f = (string) $form->{$prefix.$ns.'_'.$k};
-					settype($f,$v['type']);
-					
-					$core->blog->settings->$ns->put($k,$f,null,null,true,$global);
-					$form->{$prefix.$ns.'_'.$k} = $f;
-				}
+# Local navigation
+if (!empty($_POST['gs_nav'])) {
+	http::redirect($p_url.$_POST['gs_nav']);
+	exit;
+}
+if (!empty($_POST['ls_nav'])) {
+	http::redirect($p_url.$_POST['ls_nav']);
+	exit;
+}
+
+# Local settings update
+if (!empty($_POST['s']) && is_array($_POST['s']))
+{
+	try
+	{
+		foreach ($_POST['s'] as $ns => $s)
+		{
+			$core->blog->settings->addNamespace($ns);
+			
+			foreach ($s as $k => $v) 	{
+				$core->blog->settings->$ns->put($k,$v);
 			}
+			
 			$core->blog->triggerBlog();
-			
-			http::redirect(self::$p_url.'&upd=1&part='.$part);
-		}
-		catch (Exception $e) {
-			$_ctx->addError($e->getMessage());
-		}
-	}
-	
-	# Set nav and settings forms
-	public static function setForms($global=false)
-	{
-		global $core, $_ctx;
-		
-		$prefix = $global ? 'global_' : 'local_';
-		$action = $global ? 'updGlobal' : 'updLocal';
-		
-		if (!empty($_POST[$prefix.'nav'])) {
-			http::redirect(self::$p_url.$_POST[$prefix.'nav']);
-			exit;
 		}
 		
-		$nav_form = new dcForm($core,$prefix.'nav_form','plugin.php');
-		$settings_form = new dcForm($core,$prefix.'settings_form','plugin.php');
-		
-		$settings = $combo = array();
-		foreach ($core->blog->settings->dumpNamespaces() as $ns => $namespace) {
-			$ns_settings = $global ? 
-				$namespace->dumpGlobalSettings() : $namespace->dumpSettings();
-			
-			foreach ($ns_settings as $k => $v) {
-				$settings[$ns][$k] = $v;
+		http::redirect($p_url.'&upd=1');
+	}
+	catch (Exception $e)
+	{
+		$core->error->add($e->getMessage());
+	}
+}
+
+# Global settings update
+if (!empty($_POST['gs']) && is_array($_POST['gs']))
+{
+	try
+	{
+		foreach ($_POST['gs'] as $ns => $s)
+		{
+			$core->blog->settings->addNamespace($ns);
+			
+			foreach ($s as $k => $v) 	{
+				$core->blog->settings->$ns->put($k,$v,null,null,true,true);
 			}
+			
+			$core->blog->triggerBlog();
 		}
 		
-		ksort($settings);
-		foreach ($settings as $ns => $s) {
-			$combo['#'.$prefix.$ns] = $ns;
-			ksort($s);
-			foreach ($s as $k => $v)	{
-				if ($v['type'] == 'boolean') {
-					$settings_form->addField(
-						new dcFieldCombo($prefix.$ns.'_'.$k,
-							'',array(1 => __('yes'),0 => __('no'))));
-				}
-				else {
-					$settings_form->addField(
-						new dcFieldText($prefix.$ns.'_'.$k,''));
-				}
-				$settings_form->{$prefix.$ns.'_'.$k} = $v['value'];
-			}
-		}
-		
-		$nav_form
-			->addField(
-				new dcFieldCombo($prefix.'nav','',$combo,array(
-					"label" => __('Goto:'))))
-			->addField(
-				new dcFieldSubmit($prefix.'nav_submit',__('OK')))
-			->addField(
-				new dcFieldHidden ('p','aboutConfig'))
-			;
-		
-		$settings_form
-			->addField(
-				new dcFieldSubmit($prefix.'submit',__('Save'),array(
-					'action' => array('adminPageAboutConfig',$action))))
-			->addField(
-				new dcFieldHidden ('p','aboutConfig'))
-			;
-		
-		$_ctx->{$prefix.'settings'} = $settings;
-		
-		$nav_form->setup();
-		$settings_form->setup();
-	}
-}
-
-# Local settings forms
-adminPageAboutConfig::setForms();
-
-# Global settings forms
-adminPageAboutConfig::setForms(true);
-
-# Commons
+		http::redirect($p_url.'&upd=1&part=global');
+	}
+	catch (Exception $e)
+	{
+		$core->error->add($e->getMessage());
+	}
+}
+
+$part = !empty($_GET['part']) && $_GET['part'] == 'global' ? 'global' : 'local';
+
+function settingLine($id,$s,$ns,$field_name,$strong_label)
+{
+	if ($s['type'] == 'boolean') {
+		$field = form::combo(array($field_name.'['.$ns.']['.$id.']',$field_name.'_'.$id),
+		array(__('yes') => 1, __('no') => 0),$s['value']);
+	} else {
+		$field = form::field(array($field_name.'['.$ns.']['.$id.']',$field_name.'_'.$id),40,null,
+		html::escapeHTML($s['value']));
+	}
+	
+	$slabel = $strong_label ? '<strong>%s</strong>' : '%s';
+	
+	return
+	'<tr>'.
+	'<td scope="raw"><label for="s_'.$id.'">'.sprintf($slabel,html::escapeHTML($id)).'</label></td>'.
+	'<td>'.$field.'</td>'.
+	'<td>'.$s['type'].'</td>'.
+	'<td>'.html::escapeHTML($s['label']).'</td>'.
+	'</tr>';
+}
+?>
+<html>
+<head>
+  <title>about:config</title>
+  <?php echo dcPage::jsPageTabs($part); ?>
+  <style type="text/css">
+  table.settings { border: 1px solid #999; margin-bottom: 2em; }
+  table.settings th { background: #f5f5f5; color: #444; padding-top: 0.3em; padding-bottom: 0.3em; }
+  p.anchor-nav {float: right; }
+  </style>
+	<script type="text/javascript">
+	//<![CDATA[
+	$(function() {
+		$("#gs_submit").hide();
+		$("#ls_submit").hide();
+		$("#gs_nav").change(function() {
+			window.location = $("#gs_nav option:selected").val();
+		})
+		$("#ls_nav").change(function() {
+			window.location = $("#ls_nav option:selected").val();
+		})
+	});
+	//]]>
+	</script>
+</head>
+
+<body>
+<?php
 if (!empty($_GET['upd'])) {
-	$_ctx->setAlert(__('Configuration successfully updated'));
-}
+	dcPage::message(__('Configuration successfully updated'));
+}
+
 if (!empty($_GET['upda'])) {
-	$_ctx->setAlert(__('Settings definition successfully updated'));
-}
-$_ctx->default_tab = !empty($_GET['part']) && $_GET['part'] == 'global' ? 'global' : 'local';
-$_ctx->fillPageTitle('about:config');
-$core->tpl->display('@aboutConfig/index.html.twig');
-?>
+	dcPage::message(__('Settings definition successfully updated'));
+}
+?>
+<h2><?php echo html::escapeHTML($core->blog->name); ?> &rsaquo; <span class="page-title">about:config</span></h2>
+
+<div id="local" class="multi-part" title="<?php echo __('blog settings'); ?>">
+
+<?php 
+$table_header = '<table class="settings" id="%s"><caption>%s</caption>'.
+'<thead>'.
+'<tr>'."\n".
+'  <th class="nowrap">Setting ID</th>'."\n".
+'  <th>'.__('Value').'</th>'."\n".
+'  <th>'.__('Type').'</th>'."\n".
+'  <th class="maximalx">'.__('Description').'</th>'."\n".
+'</tr>'."\n".
+'</thead>'."\n".
+'<tbody>';
+$table_footer = '</tbody></table>';
+
+$settings = array();
+foreach ($core->blog->settings->dumpNamespaces() as $ns => $namespace) {
+	foreach ($namespace->dumpSettings() as $k => $v) {
+		$settings[$ns][$k] = $v;
+	}
+}
+ksort($settings);
+if (count($settings) > 0) {
+	$ns_combo = array();
+	foreach ($settings as $ns => $s) {
+		$ns_combo[$ns] = '#l_'.$ns;
+	}
+	echo 
+		'<form action="plugin.php" method="post">'.
+		'<p class="anchor-nav">'.
+		'<label for="ls_nav" class="classic">'.__('Goto:').'</label> '.form::combo('ls_nav',$ns_combo).
+		' <input type="submit" value="'.__('Ok').'" id="ls_submit" />'.
+		'<input type="hidden" name="p" value="aboutConfig" />'.
+		$core->formNonce().'</p></form>';
+}
+?>
+
+<form action="plugin.php" method="post">
+
+<?php
+foreach ($settings as $ns => $s)
+{
+	ksort($s);
+	echo sprintf($table_header,'l_'.$ns,$ns);
+	foreach ($s as $k => $v)
+	{
+		echo settingLine($k,$v,$ns,'s',!$v['global']);
+	}
+	echo $table_footer;
+}
+?>
+
+<p><input type="submit" value="<?php echo __('Save'); ?>" />
+<input type="hidden" name="p" value="aboutConfig" />
+<?php echo $core->formNonce(); ?></p>
+</form>
+</div>
+
+<div id="global" class="multi-part" title="<?php echo __('global settings'); ?>">
+
+<?php
+$settings = array();
+
+foreach ($core->blog->settings->dumpNamespaces() as $ns => $namespace) {
+	foreach ($namespace->dumpGlobalSettings() as $k => $v) {
+		$settings[$ns][$k] = $v;
+	}
+}
+
+ksort($settings);
+
+if (count($settings) > 0) {
+	$ns_combo = array();
+	foreach ($settings as $ns => $s) {
+		$ns_combo[$ns] = '#g_'.$ns;
+	}
+	echo 
+		'<form action="plugin.php" method="post">'.
+		'<p class="anchor-nav">'.
+		'<label for="gs_nav" class="classic">'.__('Goto:').'</label> '.form::combo('gs_nav',$ns_combo).
+		' <input type="submit" value="'.__('Ok').'" id="gs_submit" />'.
+		'<input type="hidden" name="p" value="aboutConfig" />'.
+		$core->formNonce().'</p></form>';
+}
+?>
+
+<form action="plugin.php" method="post">
+
+<?php
+foreach ($settings as $ns => $s)
+{
+	ksort($s);
+	echo sprintf($table_header,'g_'.$ns,$ns);
+	foreach ($s as $k => $v)
+	{
+		echo settingLine($k,$v,$ns,'gs',false);
+	}
+	echo $table_footer;
+}
+?>
+
+<p><input type="submit" value="<?php echo __('Save'); ?>" />
+<input type="hidden" name="p" value="aboutConfig" />
+<?php echo $core->formNonce(); ?></p>
+</form>
+</div>
+
+</body>
+</html>
Index: plugins/importExport/inc/flat/class.flat.import.php
===================================================================
--- plugins/importExport/inc/flat/class.flat.import.php	(revision 841)
+++ plugins/importExport/inc/flat/class.flat.import.php	(revision 1093)
@@ -790,6 +790,6 @@
 		$strReq = 'SELECT media_id '.
 				'FROM '.$this->prefix.'media '.
-				"WHERE media_path = '".$this->cur_media->media_path."' ".
-				"AND media_file = '".$this->cur_media->media_file."' ";
+				"WHERE media_path = '".$this->con->escape($this->cur_media->media_path)."' ".
+				"AND media_file = '".$this->con->escape($this->cur_media->media_file)."' ";
 		
 		$rs = $this->con->select($strReq);
Index: themes/ductile/_config.php
===================================================================
--- themes/ductile/_config.php	(revision 1011)
+++ themes/ductile/_config.php	(revision 1081)
@@ -44,6 +44,4 @@
 }
 
-
-
 $contexts = array(
 	'default' => __('Home (first page)'),
@@ -67,4 +65,10 @@
 	__('Impact') => 'Impact',
 	__('Monospace') => 'Monospace'
+);
+
+$webfont_apis = array(
+	__('none') => '',
+	__('javascript (Adobe)') => 'js',
+	__('stylesheet (Google)') => 'css'
 );
 
@@ -227,5 +231,11 @@
 	// CSS
 	'body_font' => null,
+	'body_webfont_family' => null,
+	'body_webfont_url' => null,
+	'body_webfont_api' => null,
 	'alternate_font' => null,
+	'alternate_webfont_family' => null,
+	'alternate_webfont_url' => null,
+	'alternate_webfont_api' => null,
 	'blog_title_w' => null,
 	'blog_title_s' => null,
@@ -368,5 +378,12 @@
 		if ($conf_tab == 'css') {
 			$ductile_user['body_font'] = $_POST['body_font'];
+			$ductile_user['body_webfont_family'] = $_POST['body_webfont_family'];
+			$ductile_user['body_webfont_url'] = $_POST['body_webfont_url'];
+			$ductile_user['body_webfont_api'] = $_POST['body_webfont_api'];
+
 			$ductile_user['alternate_font'] = $_POST['alternate_font'];
+			$ductile_user['alternate_webfont_family'] = $_POST['alternate_webfont_family'];
+			$ductile_user['alternate_webfont_url'] = $_POST['alternate_webfont_url'];
+			$ductile_user['alternate_webfont_api'] = $_POST['alternate_webfont_api'];
 
 			$ductile_user['blog_title_w'] = (integer) !empty($_POST['blog_title_w']);
@@ -507,15 +524,37 @@
 echo '<h3>'.__('General settings').'</h3>';
 
-echo '<fieldset><legend>'.__('Fonts').'</legend>'.
+echo '<fieldset><legend>'.__('Fonts').'</legend>';
+
+echo '<div class="two-cols">';
+echo '<div class="col">';
+echo
 '<p class="field"><label for="body_font">'.__('Main:').' '.
 form::combo('body_font',$fonts,$ductile_user['body_font']).'</label>'.
 (!empty($ductile_user['body_font']) ? ' '.fontDef($ductile_user['body_font']) : '').
 '</p>'.
-
+'<p class="form-note">'.__('Set main font to default to use webfont below.').'</p> '.
+'<p class="field"><label for="body_webfont_family">'.__('Webfont family:').'</label> '.
+form::field('body_webfont_family',25,255,$ductile_user['body_webfont_family']).'</p>'.
+'<p class="field"><label for="body_webfont_url">'.__('Webfont URL:').'</label> '.
+form::field('body_webfont_url',50,255,$ductile_user['body_webfont_url']).'</p>'.
+'<p class="field"><label for="body_webfont_url">'.__('Webfont API:').' '.
+form::combo('body_webfont_api',$webfont_apis,$ductile_user['body_webfont_api']).'</label>'.'</p>';
+echo '</div>';
+echo '<div class="col">';
+echo
 '<p class="field"><label for="alternate_font">'.__('Secondary:').' '.
 form::combo('alternate_font',$fonts,$ductile_user['alternate_font']).'</label>'.
 (!empty($ductile_user['alternate_font']) ? ' '.fontDef($ductile_user['alternate_font']) : '').
 '</p>'.
-'</fieldset>';
+'<p class="form-note">'.__('Set secondary font to default to use webfont below.').'</p> '.
+'<p class="field"><label for="alternate_webfont_family">'.__('Webfont family:').'</label> '.
+form::field('alternate_webfont_family',25,255,$ductile_user['alternate_webfont_family']).'</p>'.
+'<p class="field"><label for="alternate_webfont_url">'.__('Webfont URL:').'</label> '.
+form::field('alternate_webfont_url',50,255,$ductile_user['alternate_webfont_url']).'</p>'.
+'<p class="field"><label for="alternate_webfont_api">'.__('Webfont API:').' '.
+form::combo('alternate_webfont_api',$webfont_apis,$ductile_user['alternate_webfont_api']).'</label>'.'</p>';
+echo '</div>';
+echo '</div>';
+echo '</fieldset>';
 
 echo '<div class="two-cols">';
Index: themes/ductile/_public.php
===================================================================
--- themes/ductile/_public.php	(revision 1045)
+++ themes/ductile/_public.php	(revision 1081)
@@ -250,4 +250,73 @@
 			$core->blog->settings->system->themes_url.'/'.$core->blog->settings->system->theme.
 			'/ductile.js"></script>'."\n";
+
+		echo self::ductileWebfontHelper();
+	}
+
+	public static function ductileWebfontHelper()
+	{
+		$s = $GLOBALS['core']->blog->settings->themes->get($GLOBALS['core']->blog->settings->system->theme.'_style');
+
+		if ($s === null) {
+			return;
+		}
+
+		$s = @unserialize($s);
+		if (!is_array($s)) {
+			return;
+		}
+
+		$ret = '';
+		$css = array();
+		$uri = array();
+		if (!isset($s['body_font']) || ($s['body_font'] == '')) {
+			// See if webfont defined for main font
+			if (isset($s['body_webfont_api']) && isset($s['body_webfont_family']) && isset($s['body_webfont_url'])) {
+				$uri[] = $s['body_webfont_url'];
+				switch ($s['body_webfont_api']) {
+					case 'js':
+						$ret .= sprintf('<script type="text/javascript" src="%s"></script>',$s['body_webfont_url'])."\n";
+						break;
+					case 'css':
+						$ret .= sprintf('<link type="text/css" href="%s" rel="stylesheet" />',$s['body_webfont_url'])."\n";
+						break;
+				}
+				# Main font
+				$selectors = 'body, .supranav li a span, #comments.me, a.comment-number';
+				self::prop($css,$selectors,'font-family',$s['body_webfont_family']);
+			}
+		}
+		if (!isset($s['alternate_font']) || ($s['alternate_font'] == '')) {
+			// See if webfont defined for secondary font
+			if (isset($s['alternate_webfont_api']) && isset($s['alternate_webfont_family']) && isset($s['alternate_webfont_url'])) {
+				if (!in_array($s['alternate_webfont_url'], $uri)) {
+					switch ($s['alternate_webfont_api']) {
+						case 'js':
+							$ret .= sprintf('<script type="text/javascript" src="%s"></script>',$s['alternate_webfont_url'])."\n";
+							break;
+						case 'css':
+							$ret .= sprintf('<link type="text/css" href="%s" rel="stylesheet" />',$s['alternate_webfont_url'])."\n";
+							break;
+					}
+				}
+				# Secondary font
+				$selectors = '#blogdesc, .supranav, #content-info, #subcategories, #comments-feed, #sidebar h2, #sidebar h3, #footer';
+				self::prop($css,$selectors,'font-family',$s['alternate_webfont_family']);
+			}
+		}
+		# Style directives
+		$res = '';
+		foreach ($css as $selector => $values) {
+			$res .= $selector." {\n";
+			foreach ($values as $k => $v) {
+				$res .= $k.':'.$v.";\n";
+			}
+			$res .= "}\n";
+		}
+		if ($res != '') {
+			$ret .= '<style type="text/css">'."\n".$res.'</style>'."\n";
+		}
+
+		return $ret;
 	}
 	
